<template>
	<div :class="showAffirm ? $style.productWithAffirm : $style.product">
		<div :class="[$style.header, { [$style.hasDiscount]: discount }]">
			<h3 :class="titleDesktop ? $style.titleMobile : $style.title">{{ titleMobile }}</h3>
			<h3 v-if="titleDesktop" :class="$style.titleDesktop">{{ titleDesktop }}</h3>
			<p v-if="discount" :class="$style.discount">{{ `— Save ${currencyDisplay}${discount} —` }}</p>
			<div
				v-if="shouldMakeSpaceForReviews"
				:class="[
					$style.reviewAndShipWrapper,
					{
						[$style.isEmpty]: !powerreviewsPageId && !shipMessage,
						[$style.hasReviewsAndShipMessage]: hasReviewsAndShipMessage,
					},
				]"
			>
				<div :class="$style.reviewOrShipMessage">
					<MoleculeReviewInfo :link="reviewsLink && reviewsLink.url" :page-id="powerreviewsPageId" />
					<p v-if="shipMessage && !powerreviewsPageId" :class="$style.shipMessage">{{ shipMessage }}</p>
				</div>
				<div v-if="shipMessage && powerreviewsPageId" :class="$style.separateShipMessage">
					<p :class="$style.shipMessage">{{ shipMessage }}</p>
				</div>
			</div>
			<p v-if="description" :class="$style.description">{{ description }}</p>
		</div>
		<div :class="$style.productImageWrapper">
			<BaseImage
				:image="imageMobile"
				:images="{ medium: image }"
				:sizes="`(min-width: ${$style.largeBreakpoint}) calc((100w - 1.25rem) / 3 - 7.5rem), (min-width: ${$style.mediumBreakpoint}) calc((100w - 1.25rem) / 3 - 3.75rem), calc((100vw - 1.25rem) / 2)`"
				compression-level="medium"
				:critical="critical"
			/>
			<BlockWatermark
				v-if="watermarkImage"
				:critical="critical"
				:image="watermarkImage"
				:images="watermarkImages"
				:watermark-height="watermarkHeight"
				:watermark-width="watermarkWidth"
				:watermark-opacity="watermarkOpacity"
				:watermark-position="watermarkPosition"
			/>
		</div>
		<div v-if="productOrBundle && Object.keys(productOrBundle).length" :class="$style.productPriceWrapper">
			<MoleculeProductPrice
				:current-price="productOrBundle.currentPrice"
				:list-price="productOrBundle.listPrice"
				:available-for-pre-order="$store.state.globalData.magento.preOrders[productOrBundle.sku]"
				affirm-text-color="primary"
				appearance="secondary"
				bottom-outside
				:affirm="showAffirm"
			/>
		</div>
		<BaseButton
			v-if="productOrBundle || (ctaLink && ctaLink.url)"
			:class="[$style.cta, { [$style.hasNoProductPrice]: !(productOrBundle && Object.keys(productOrBundle).length) }]"
			size="medium"
			appearance="primary"
			:smart="(ctaLink && ctaLink.url) || (productOrBundle.sku && `/add-to-cart?skus=${productOrBundle.sku}`)"
			>{{ ctaText }}</BaseButton
		>
	</div>
</template>

<script>
import { mapState } from 'vuex';
import MoleculeReviewInfo from '@components/molecule-review-info';
import MoleculeProductPrice from '@components/molecule-product-price';
import BlockWatermark from '@components/block-watermark';

export default {
	components: {
		MoleculeReviewInfo,
		MoleculeProductPrice,
		BlockWatermark,
	},

	inheritAttrs: false,

	props: {
		titleMobile: {
			type: String,
			required: true,
		},

		titleDesktop: {
			type: String,
			default: '',
		},

		imageMobile: {
			type: Object,
			required: true,
		},

		image: {
			type: Object,
			required: true,
		},

		ctaText: {
			type: String,
			default: '',
		},

		ctaLink: {
			type: Object,
			default: () => ({}),
		},

		shipMessage: {
			type: String,
			default: '',
		},

		description: {
			type: String,
			default: '',
		},

		discount: {
			type: Number,
			default: 0,
		},

		showAffirm: {
			type: Boolean,
			default: true,
		},

		productOrBundle: {
			type: Object,
			default: () => ({}),
		},

		powerreviewsPageId: {
			type: String,
			default: '',
		},

		reviewsLink: {
			type: Object,
			default: null,
		},

		shouldMakeSpaceForReviews: {
			type: Boolean,
			default: false,
		},

		hasReviewsAndShipMessage: {
			type: Boolean,
			default: false,
		},

		critical: {
			type: Boolean,
			required: true,
		},

		watermarkImage: {
			type: [Object, String],
			default: null,
		},

		watermarkImages: {
			type: Object,
			default: () => ({}),
		},

		watermarkPosition: {
			type: String,
			default: 'Center',
		},

		watermarkWidth: {
			type: Number,
			default: 100,
		},

		watermarkHeight: {
			type: Number,
			default: 50,
		},

		watermarkOpacity: {
			type: Number,
			default: 0.5,
		},
	},
	computed: {
		...mapState(['currencyDisplay']),
	},
};
</script>

<style lang="scss" module>
@import '@design';

:export {
	/* stylelint-disable-next-line property-no-unknown */
	mediumBreakpoint: break('medium');
	/* stylelint-disable-next-line property-no-unknown */
	largeBreakpoint: break('large');
}

.product {
	position: relative;
	display: flex;
	flex-direction: column;
	align-items: center;
	height: 100%;
	text-align: center;

	:global(.affirm-pmt-bottom) {
		text-align: center;
	}
}

.productWithAffirm {
	composes: product;
	padding: 0 0 5.5rem;

	@include above('medium') {
		padding: 0 0 8.5rem;
	}
}

.header {
	margin-bottom: 3.3rem;
	color: color('primary-300');

	@include above('medium') {
		order: 1;
		margin: 0 0 auto;
	}
}

.title {
	@include use-text-style('heading-300');

	font-family: font-family('secondary');

	@include above('medium') {
		@include use-text-style('heading-150');
	}
}

.titleMobile {
	composes: title;

	@include above('medium') {
		display: none;
	}
}

.titleDesktop {
	composes: title;

	@include below('medium') {
		display: none;
	}
}

.discount {
	@include use-text-style('type-500');

	margin: 0.3rem 0 0;
	font-weight: 300;
	color: color('primary');
}

.description {
	@include use-text-style('type-500');

	margin: 1.5rem 0 1.6rem;
	font-weight: 300;
	color: color('primary');

	@include above('medium') {
		@include use-text-style('type-100');

		margin: 1.9rem 0 0;
	}
}

.shipMessage {
	composes: description;
	display: flex;
	align-items: center;
	justify-content: center;
	margin: 0;
}

.reviewAndShipWrapper {
	display: flex;
	flex-direction: column;
	margin: 1.5rem 0 0;
	font-weight: 300;
	white-space: normal;

	[class*='starsWrapper'],
	[class*='starsWrapper'] svg {
		width: 9.1em;
		height: 1.4em;
		margin: 0 auto;
	}

	&.isEmpty {
		display: none;

		@include above('medium') {
			display: flex;
		}
	}

	.hasDiscount & {
		@include above('medium') {
			margin: 0.5rem 0 0;
		}
	}

	@include above('medium') {
		height: 4rem;
		margin: 3rem 0 0;

		&.hasReviewsAndShipMessage {
			height: 6.3rem;
		}
	}
}

.reviewOrShipMessage {
	display: flex;
	justify-content: center;

	@include above('medium') {
		height: 4rem;
	}
}

.separateShipMessage {
	margin: 0.5rem 0 0;

	@include above('medium') {
		height: 1.7rem;
	}
}

.productImageWrapper {
	position: relative;
	display: flex;
	flex: 1 0 auto;
	align-items: flex-end;
	width: 100%;
	max-width: 28.1rem;
	margin: auto 0 0;

	@include above('medium') {
		order: 0;
		max-width: unset;
		margin: 0 0 2rem;
	}
}

.productPriceWrapper {
	padding: 2rem 0 0;

	@include above('medium') {
		order: 2;
	}
}

.cta {
	@include above('medium') {
		order: 3;
	}

	&.hasNoProductPrice {
		margin: 2rem 0 0;

		@include above('medium') {
			margin: 2.4rem 0 0;
		}
	}
}
</style>
